unit RemoteControl2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;
         
type
  TControlRemoto2 = class(TTimer)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    procedure Init;
    function Button: Integer;
    procedure Close;

  published
    { Published declarations }
  end;

procedure Register;

implementation



type
funcion = function:Integer; cdecl;
funcionInt = function(value: Integer):Integer; cdecl;

var
hTvAver: HINST;
IsRemoteDataReady: funcion;
GetRemoteData: funcion;
SetRemoteFlag: funcionInt;

prev: Integer;

procedure TControlRemoto2.Init;
begin
hTvAver := LoadLibrary('avertv32.dll');

if (hTvAver <> 0) then
begin
  IsRemoteDataReady := funcion(GetProcAddress(hTvAver, 'AVER_IsRemoteDataReady'));
  GetRemoteData := funcion(GetProcAddress(hTvAver, 'AVER_GetRemoteData'));
  SetRemoteFlag := funcionInt(GetProcAddress(hTvAver, 'AVER_SetRemoteFlag'));

if Assigned(IsRemoteDataReady) then
  SetRemoteFlag(0)
else
  SetRemoteFlag(1)
end
else
  ShowMessage('Fallo');
end;




function TControlRemoto2.Button: Integer;
var
Key: Integer;
begin
Result:=0;

if (hTvAver<>0) then
begin
if not (Assigned(IsRemoteDataReady)) then
begin
Key:=GetRemoteData();

if (Key=prev) then
Exit;

prev:=Key;


end
else
begin
if (IsRemoteDataReady()=1) then
begin
 SetRemoteFlag(1);
 Key:=GetRemoteData();
 SetRemoteFlag(0);
 Key := Key and 191;
if (Key<128) then
Exit;

if ((prev=Key) and (IsRemoteDataReady()=1)) then
Exit;

prev:=Key;
// switch (key)
// again select what to do
end
else
prev:=0;

end;
end;
 Result:=prev;
end;



procedure   TControlRemoto2.Close;
 Begin
   FreeLibrary(hTvAver);
 end;


procedure Register;
begin
  RegisterComponents('HirsfielD', [TControlRemoto2]);
end;

end.
